//#include <windows.h> jun
//#pragma hdrstop jun


#include "f00Point2D.h"


#include <math.h>
#include <assert.h>


f00Point2D::f00Point2D( GLfloat* pArray )
:	d_u( d_array[ 0 ] ),
	d_v( d_array[ 1 ] )
{
	assert( pArray );
	memcpy( d_array, pArray, 4 * sizeof( GLfloat ) );
}


f00Point2D::f00Point2D( GLfloat u, GLfloat v )
:	d_u( d_array[ 0 ] ),
	d_v( d_array[ 1 ] )
{
	set( u, v );
}


f00Point2D::f00Point2D( const f00Point2D& copyFrom )
:	d_u( d_array[ 0 ] ),
	d_v( d_array[ 1 ] )
{
	*this = copyFrom;
}


f00Point2D&
f00Point2D::operator = ( const f00Point2D& copyFrom )
{
	memcpy( d_array, copyFrom.d_array, 2 * sizeof( GLfloat ) );
	return *this;
}


GLdouble
f00Point2D::length( const f00Point2D& pointA )
{
	return( sqrt( pointA.d_u * pointA.d_u + pointA.d_v * pointA.d_v ) );
}


GLdouble
f00Point2D::length() const
{
	return length( *this );
}


void
f00Point2D::normalize( f00Point2D& pointA )
{
	GLdouble radius = pointA.length();
	if( radius == 0. )
	{
		pointA.d_u = 1.0;		// Just set it arbitratily.
		return;
	}

	pointA.d_u /= radius;
	pointA.d_v /= radius;
}


void
f00Point2D::normalize()
{
	normalize( *this );
}



